<%@ Page ContentType="text/xml" EnableViewState="false" Explicit="true"%>
<%
'*********************************************************************************
' COMobjects.NET Deep Tree Script(c) Fedor Skvortsov, COMobjects.NET. November, 2001
' Mailto: fed@comobjects.net
' WWW: http://comobjects.net
'*********************************************************************************

'Change this variable to specify root folder
'Should be empty or ended to slash
Dim strRootPath As String
strRootPath = "/"
'Get relative path
Dim strPath As String
strPath = Request.QueryString("path")
'Prevent using path ../../ which allows somebody to go higher that root folder
If InStr(1, Server.MapPath(strRootPath & strPath), Server.MapPath(strRootPath), 1) <> 1 Then
	Err.Raise 7101, "COMobjectsNET.DeepTree", "Security Error"
	Response.End
End If
'Creating xml document
Dim xmlDoc As System.Xml.XmlDocument
Dim xmlPI As System.Xml.XmlProcessingInstruction
Dim xmlElement As System.Xml.XmlElement
Dim xmlAtt As System.Xml.XmlAttribute
xmlDoc = New System.Xml.XmlDocument
'Set encoding of XML document
xmlPI = xmlDoc.appendChild(xmlDoc.createProcessingInstruction("xml", "version='1.0' encoding='Windows-1252'"))
'Create root element and set base attribute
xmlElement = xmlDoc.appendChild(xmlDoc.createElement("Tree"))
xmlAtt = xmlDoc.documentElement.Attributes.setNamedItem(xmlDoc.createAttribute("base"))
xmlAtt.Value = strRootPath & strPath
'Reading subfolder and files
Dim objDirectory, objSubDirectory As System.IO.DirectoryInfo, objFile As System.IO.FileInfo
Dim objSubDirectories() As System.IO.DirectoryInfo
Dim objFiles() As System.IO.FileInfo
objDirectory = New System.IO.DirectoryInfo(Server.MapPath(strRootPath & strPath))
objSubDirectories = objDirectory.GetDirectories()
For Each objSubDirectory In objSubDirectories
	'Create tree node
    xmlElement = xmlDoc.documentElement.appendChild(xmlDoc.createElement("TreeNode"))
	'Set attribute "icon" to value "folder"
    xmlAtt = xmlElement.Attributes.setNamedItem(xmlDoc.createAttribute("icon"))
	xmlAtt.value = "folder"
	'Make attribute "name" equal to folder name		
    xmlAtt = xmlElement.Attributes.setNamedItem(xmlDoc.createAttribute("name"))
	xmlAtt.value = objSubDirectory.Name
	'Using attribute "src" for linking it to subtree		
	xmlAtt = xmlElement.Attributes.setNamedItem(xmlDoc.createAttribute("src"))
	xmlAtt.value = "Files.aspx?path=" & Server.URLEncode(strPath & objSubDirectory.Name & "/")
Next
objFiles = objDirectory.GetFiles()
For Each objFile In objFiles
	'Create tree node
    xmlElement = xmlDoc.documentElement.appendChild(xmlDoc.createElement("TreeNode"))
	'Set attribute "icon" to value "item"    
    xmlAtt = xmlElement.Attributes.setNamedItem(xmlDoc.createAttribute("icon"))
	xmlAtt.value = "item"
	'Make attribute "name" equal to file name	
    xmlAtt = xmlElement.Attributes.setNamedItem(xmlDoc.createAttribute("name"))
	xmlAtt.value = objFile.Name	
	'Set attribute "target"		
    xmlAtt = xmlElement.Attributes.setNamedItem(xmlDoc.createAttribute("target"))
	xmlAtt.value = "main"	
	 'Combine attributes "href" and "base" of root element to get link to the file			
    xmlAtt = xmlElement.Attributes.setNamedItem(xmlDoc.createAttribute("href"))
	xmlAtt.value = objFile.Name
Next
'Write directly to response stream
xmlDoc.save(Response.OutputStream)
%>
